diff --git a/src/iperf_api.c b/src/iperf_api.c
index 11d261479..846acaae9 100644
--- a/src/iperf_api.c
+++ b/src/iperf_api.c
@@ -1719,23 +1719,6 @@ iperf_reset_test(struct iperf_test *test)
     test->duration = DURATION;
     test->server_affinity = -1;
     test->state = 0;
-
-    if(test->title) {
-        free(test->title);
-        test->title = NULL;
-    }
-    if(test->server_hostname) {
-        free(test->server_hostname);
-        test->server_hostname = NULL;
-    }
-    if(test->bind_address) {
-        free(test->bind_address);
-        test->bind_address = NULL;
-    }
-    if(test->congestion) {
-        free(test->congestion);
-        test->congestion = NULL;
-    }
     
     test->ctrl_sck = -1;
     test->prot_listener = -1;
diff --git a/src/locale.c b/src/locale.c
index f07d51580..a9aaf024e 100644
--- a/src/locale.c
+++ b/src/locale.c
@@ -81,6 +81,7 @@ const char usage_longstr[] = "Usage: iperf [-s|-c host] [options]\n"
                            "  -i, --interval  #         seconds between periodic bandwidth reports\n"
                            "  -F, --file name           xmit/recv the specified file\n"
                            "  -A, --affinity n/n,m      set CPU affinity\n"
+                           "  -B, --bind      <host>    bind to a specific interface\n"
                            "  -V, --verbose             more detailed output\n"
                            "  -J, --json                output in JSON format\n"
                            "  -d, --debug               emit debugging output\n"
@@ -103,7 +104,6 @@ const char usage_longstr[] = "Usage: iperf [-s|-c host] [options]\n"
                            "  -P, --parallel  #         number of parallel client streams to run\n"
                            "  -R, --reverse             run in reverse mode (server sends, client receives)\n"
                            "  -w, --window    #[KMG]    TCP window size (socket buffer size)\n"
-                           "  -B, --bind      <host>    bind to a specific interface or multicast address\n"
 #if defined(linux)
                            "  -C, --linux-congestion <algo>  set TCP congestion control algorithm (Linux only)\n"
 #endif
diff --git a/src/net.c b/src/net.c
index 3e0041d8b..99b238b78 100644
--- a/src/net.c
+++ b/src/net.c
@@ -104,7 +104,7 @@ netannounce(int domain, int proto, char *local, int port)
 
     snprintf(portstr, 6, "%d", port);
     memset(&hints, 0, sizeof(hints));
-    hints.ai_family = (domain == AF_UNSPEC ? AF_INET6 : domain);
+    hints.ai_family = domain;
     hints.ai_socktype = proto;
     hints.ai_flags = AI_PASSIVE;
     if (getaddrinfo(local, portstr, &hints, &res) != 0)
@@ -123,10 +123,10 @@ netannounce(int domain, int proto, char *local, int port)
 	freeaddrinfo(res);
 	return -1;
     }
-    if (domain == AF_UNSPEC || domain == AF_INET6) {
+    if (res->ai_family == AF_INET6 && (domain == AF_UNSPEC || domain == AF_INET6)) {
 	if (domain == AF_UNSPEC)
 	    opt = 0;
-	else if (domain == AF_INET6)
+	else
 	    opt = 1;
 	if (setsockopt(s, IPPROTO_IPV6, IPV6_V6ONLY, 
 		       (char *) &opt, sizeof(opt)) < 0) {
